<app-header title="Agenda" color="white" [border]="false">
    <!-- Title-->
    <ion-text
        description
        class="weight-500 size-16"
        data-test-id="description"
        color="silver-dark"
        >Votre calendrier de consultation</ion-text
    >
    <!-- Calendar icon-->
    <ion-card
        options
        class="agenda__option radius-14 mx-0 mt-4 py-5 has-background-pale-grey"
    >
        <app-button
            fill="clear"
            size="small"
            color="black"
            (onClick)="onClick()"
            icon="calendar-outline"
            iconSize="size-20"
        >
        </app-button>
    </ion-card>
</app-header>
<ion-content>
    <app-notification
        data-testid="agenda-notification"
        icon="warning"
        *ngIf="showNotification"
        iconColor="warning-light"
        iconSize="size-37"
        class="agenda__notification block ion-margin has-background-blue-pale px-6 py-0"
    >
        <ion-text message color="dark-lighter" class="size-13">
            <span *ngIf="lastCalendar; else noPlanning">
                Votre agenda de consultation arrive à échéance le
                <span class="weight-700">
                    {{ lastCalendar | date: 'dd MMMM yyyy' }}</span
                >. Pensez à le mettre à jour.
            </span>
            <ng-template #noPlanning> {{ expectHours }} </ng-template>
        </ion-text>
    </app-notification>

    <ion-row class="ion-justify-content-center ion-align-items-center">
        <!-- button back -->
        <ion-col size="auto">
            <app-button
                data-test-id="button-back"
                fill="clear"
                size="small"
                (click)="back()"
                (keyPress)="back()"
                color="dark"
                icon="chevron-back-outline"
            >
            </app-button>
        </ion-col>

        <!-- button down -->
        <ion-col size="auto">
            <ion-label
                class="flex ion-align-items-center size-15 text-secondary"
                id="open-modal"
                color="blue"
            >
                {{ calendar.currentDate |date : 'MMMM yyyy'}}
                <ion-icon
                    name="chevron-down-outline"
                    color="blue"
                    class="p-5"
                ></ion-icon>
            </ion-label>
        </ion-col>

        <!-- button next -->
        <ion-col size="auto">
            <app-button
                data-test-id="button-next"
                fill="clear"
                size="small"
                (click)="next()"
                (keyPress)="next()"
                color="dark"
                icon="chevron-forward-outline"
            >
            </app-button>
        </ion-col>
    </ion-row>

    <ion-modal
        trigger="open-modal"
        class="agenda__calendar ion-align-items-end"
    >
        <ng-template>
            <ion-datetime
                presentation="date"
                (ionChange)="onDateTimeChange($event)"
                size="cover"
                [showDefaultButtons]="true"
                max="2030"
                min="2000"
                [preferWheel]="true"
                cancelText="Annuler"
                doneText="OK"
            >
            </ion-datetime>
        </ng-template>
    </ion-modal>

    <ng-template #dayviewNormalEventTemplate let-displayEvent="displayEvent">
        <ion-card class="agenda__event radius-17 ion-no-margin">
            <ion-row class="agenda__event__container">
                <ion-col
                    size="auto"
                    [ngClass]="[
                        displayEvent.event.color,
                        'radius-9'
                    ]"
                ></ion-col>
                <ion-col class="ion-text-left pl-3">
                    <ion-label class="weight-400 is-dark">
                        {{displayEvent.event.title}}
                    </ion-label>
                </ion-col>
            </ion-row>
        </ion-card>
    </ng-template>

    <!-- Label -->
    <ion-row>
        <ion-col size="auto" class="ion-no-padding has-text-secondary">
            <div
                class="width-51 border-0 border-right-1 border-solid has-border-gray ion-text-center pb-5"
            >
                <ion-text color="primary" class="size-11 weight-200">
                    {{(calendar.currentDate |date : 'EEE' | uppercase
                    )?.replace( '.', '' )}}
                </ion-text>
                <br />
                <ion-text
                    color="white"
                    class="size-14 inline-flex radius-30 height-25 width-25 has-background-primary ion-align-items-center ion-justify-content-center"
                >
                    {{calendar.currentDate |date : 'd'}}
                </ion-text>
            </div>
        </ion-col>
    </ion-row>

    <calendar
        #calendarComponent
        [dayviewNormalEventTemplate]="dayviewNormalEventTemplate"
        [eventSource]="eventSource"
        class="text-secondary custom-dayview"
        [calendarMode]="calendar.mode"
        [currentDate]="calendar.currentDate"
        [startHour]="0"
        [endHour]="24"
        [timeInterval]="5"
        [allDayLabel]="calendar.currentDate |date : 'E d' | uppercase"
        [dateFormatter]="customDateFormatter"
        (onCurrentDateChanged)="onCurrentDateChanged($event)"
    >
    </calendar>

    <ion-fab slot="fixed" vertical="bottom" horizontal="end" class="mb-7 mr-24">
        <ion-fab-button
            routerLink="/tabs/account/agenda/schedule"
            class="agenda__schedule"
        >
            <ion-icon name="medkit-outline" color="dark"></ion-icon>
        </ion-fab-button>
    </ion-fab>
</ion-content>
